package YClass;

import java.awt.*;
import java.util.*;
import java.lang.Float;
import java.awt.event.*;
import java.io.*;

public class YChart extends Canvas {
  private Vector data;
  private Vector dataAll;  
  private boolean coordinates = false;
  private boolean proportional = false;
  private boolean pointOn=false;
  private int POINT_SIZE = 4;
  private YPoint2f[] window = {new YPoint2f(),new YPoint2f()};
  private Label x_y = new Label("XXXXXXXXXXXXXXXXXXXXXXXXX");
  private float kx=0;
  private float ky=0;
  private int ww=0;
  private int hh=0;
  private float max_x;
  private float max_y;
  private float min_x;
  private float min_y;
  private int modePoint = 1;
  private int modeCurve = 0;
  private int indexMovePoint = -1;
  private Window xyz = new Window(new Frame());
  private	YDialog dialog; 
  private TextField PointX;
  private TextField PointY;  
  private int z;  
  private int precision;
  private static float hermiteMatrix[][] = new float[4][4];
  private static float bezierMatrix[][] = new float[4][4];
  private static float bsplineMatrix[][] = new float[4][4];
  private float eMatrix[][] = new float[4][4];
  public String functionString = "";
  public float functionStart = 0;
  public float functionEnd = 360;
  public float functionStep = 1;

    // Initialize the curve-type matrices
  static {
	  hermiteMatrix[0][0] = 2;
	  hermiteMatrix[0][1] = -2;
  	hermiteMatrix[0][2] = 1;
  	hermiteMatrix[0][3] = 1;
  	hermiteMatrix[1][0] = -3;
  	hermiteMatrix[1][1] = 3;
  	hermiteMatrix[1][2] = -2;
  	hermiteMatrix[1][3] = -1;
  	hermiteMatrix[2][0] = 0;
  	hermiteMatrix[2][1] = 0;
	  hermiteMatrix[2][2] = 1;
	  hermiteMatrix[2][3] = 0;
	  hermiteMatrix[3][0] = 1;
	  hermiteMatrix[3][1] = 0;
  	hermiteMatrix[3][2] = 0;
  	hermiteMatrix[3][3] = 0;

  	bezierMatrix[0][0] = -1;
  	bezierMatrix[0][1] = 3;
  	bezierMatrix[0][2] = -3;
  	bezierMatrix[0][3] = 1;
  	bezierMatrix[1][0] = 3;
  	bezierMatrix[1][1] = -6;
  	bezierMatrix[1][2] = 3;
  	bezierMatrix[1][3] = 0;
  	bezierMatrix[2][0] = -3;
  	bezierMatrix[2][1] = 3;
	  bezierMatrix[2][2] = 0;
  	bezierMatrix[2][3] = 0;
  	bezierMatrix[3][0] = 1;
  	bezierMatrix[3][1] = 0;
  	bezierMatrix[3][2] = 0;
  	bezierMatrix[3][3] = 0;
	
	  float mult = (float)(1.0/6.0);
	  bsplineMatrix[0][0] = -mult;
  	bsplineMatrix[0][1] = 3 * mult;
  	bsplineMatrix[0][2] = -3 * mult;
  	bsplineMatrix[0][3] = mult;
  	bsplineMatrix[1][0] = 3 * mult;
  	bsplineMatrix[1][1] = -6 * mult;
	  bsplineMatrix[1][2] = 3 * mult;
  	bsplineMatrix[1][3] = 0;
  	bsplineMatrix[2][0] = -3 * mult;
  	bsplineMatrix[2][1] = 0;
  	bsplineMatrix[2][2] = 3 * mult;
  	bsplineMatrix[2][3] = 0;
  	bsplineMatrix[3][0] = mult;
  	bsplineMatrix[3][1] = 4 * mult;
  	bsplineMatrix[3][2] = mult;
  	bsplineMatrix[3][3] = 0;
  }



    /**
     * Creates a Chart.
     */
  public YChart() {
  	setPrecision(15);
  	xyz.add(x_y);
  	xyz.setBackground(Color.yellow);
  	xyz.pack();
  	xyz.validate();
  	x_y.setText("");  	
  	this.addMouseMotionListener(new MouseMotionAdapter() {
    	public void  mouseMoved(MouseEvent e) {
    		if(coordinates){
    			YChartPoint2f p = getRealPoint(e.getX(),e.getY());
    		  if(coordinates && Float.NEGATIVE_INFINITY!=p.x && Float.POSITIVE_INFINITY!=p.x && Float.NEGATIVE_INFINITY!=p.y && Float.POSITIVE_INFINITY!=p.y){
    			  x_y.setText(p.x+","+p.y);
    			  xyz.toFront();
    		  }
    		}
   	  }
   	});   	
   	this.addMouseListener(new MouseAdapter() {
    	public void  mousePressed(MouseEvent e) {
    		switch(modePoint){
    			case 0: addPoint(e.getX(),e.getY()); break;
    			case 1: editPoint(e.getX(),e.getY()); break;
    			case 2: insertPoint(e.getX(),e.getY()); break;
    			case 3: indexMovePoint = getIndexPoint(e.getX(),e.getY());
    			        window[0] = new YPoint2f();
    			        window[1] = new YPoint2f();    
    			        break;
    			case 4: deletePoint(e.getX(),e.getY()); break;
    		}
   	  }
   	});
   	this.addMouseMotionListener(new MouseMotionAdapter() {
    	public void  mouseDragged(MouseEvent e) {
   			if(data!=null && indexMovePoint!=-1 && modePoint==3){
   				data.setElementAt(getRealPoint(e.getX(),e.getY()),indexMovePoint);
   				repaint();
   			}
   			if(coordinates){
   				YChartPoint2f p = getRealPoint(e.getX(),e.getY());
    		  if(Float.NEGATIVE_INFINITY!=p.x && Float.POSITIVE_INFINITY!=p.x && Float.NEGATIVE_INFINITY!=p.y && Float.POSITIVE_INFINITY!=p.y){
    			  x_y.setText(p.x+","+p.y);
    			  xyz.toFront();
    		  }
   			}
   	  }
   	});
  }

  public void paint(Graphics g){
    float geom[][] = new float[4][2]; 
    float mg[][] = new float[4][2];    
    float plot[][] = new float[4][2];
    int i;
    int w = this.getSize().width-2;
    int h = this.getSize().height-2;
    FontMetrics fm = g.getFontMetrics();
    ww = fm.stringWidth("XXXXXXXXXXXXXX");
    hh = fm.getHeight()*2;
    g.drawRect(1,1,w,h);
    ww = ww + 1;
    hh = hh - 1;
    if(data!=null || ((window[0].x-window[1].x)!=0 && (window[0].y-window[1].y)!=0)){
       max_x=Float.MIN_VALUE;
       max_y=Float.MIN_VALUE;
       min_x=Float.MAX_VALUE;
       min_y=Float.MAX_VALUE;
       float k_x,dw,k_y,dh,step,j;
       String st;
       if(data!=null){
       	for(i=0; i<data.size(); i=i+1){
          YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
          max_x=Math.max(p.x,max_x);
          max_y=Math.max(p.y,max_y);
          min_x=Math.min(p.x,min_x);
          min_y=Math.min(p.y,min_y);
        }
      }
      if((window[0].x-window[1].x)!=0 && (window[0].y-window[1].y)!=0){
      	  max_x=Math.max(window[0].x,window[1].x);
          max_y=Math.max(window[0].y,window[1].y);
          min_x=Math.min(window[0].x,window[1].x);
          min_y=Math.min(window[0].y,window[1].y);
      }
      if(proportional){
      	if(((w-ww)/(max_x-min_x))>((h-hh)/(max_y-min_y))){
      	  float kor = ((w-ww)*(max_y-min_y)/(h-hh)-(max_x-min_x))/2;
      	  max_x=max_x+kor;
      	  min_x=min_x-kor; 
      	}else if(((w-ww)/(max_x-min_x))<((h-hh)/(max_y-min_y))){
      	  float kor = ((h-hh)*(max_x-min_x)/(w-ww)-(max_y-min_y))/2;
      	  max_y=max_y+kor;
      	  min_y=min_y-kor; 
      	}
      }
      if(pointOn){
      	max_y=max_y+(max_y-min_y)/(h-hh)*(POINT_SIZE+hh/2+4);
      	min_y=min_y-(max_y-min_y)/(h-hh)*(POINT_SIZE+4);
      	max_x=max_x+(max_x-min_x)/(w-ww)*(POINT_SIZE+hh/2+4);
      	min_x=min_x-(max_x-min_x)/(w-ww)*(POINT_SIZE+4);
      }
      k_x=(w-ww)/(max_x-min_x);
      k_y=(h-hh)/(max_y-min_y);
      kx=k_x;
      ky=k_y;
      if(min_x>0){dw=-min_x*k_x;}else{dw=-min_x*k_x;}
      if(min_y>0){dh=-min_y*k_y;}else{dh=-min_y*k_y;}
      g.setColor(Color.gray);
      step=Math.abs((max_y-min_y)/20);
      j=0; i=0;
      while(j<=max_y && min_y!=max_y){
         if(j>=min_y && j<=max_y){
            g.setColor(Color.gray);
            g.drawLine(ww,h-hh-(int)Math.round(j*k_y+dh),w,h-hh-(int)Math.round(j*k_y+dh));
            if(i==0){
               g.setColor(Color.black);
               float yi = h-hh-(int)Math.round(j*k_y+dh-hh/5);
               if(yi>=hh/2){g.drawString(j+"",5,(int)yi);}
               g.drawLine(ww-5,h-hh-(int)Math.round(j*k_y+dh),w,h-hh-(int)Math.round(j*k_y+dh));
               i=i+1;}else{
               i=0;
            }
         }
         j=j+step;
      }
      j=0; i=0;
      while(j>=min_y && min_y!=max_y){
         if(j>=min_y && j<=max_y){
            g.setColor(Color.gray);
            g.drawLine(ww,h-hh-(int)Math.round(j*k_y+dh),w,h-hh-(int)Math.round(j*k_y+dh));
            if(i==0){
               g.setColor(Color.black);
               g.drawString(j+"",5,h-hh-(int)Math.round(j*k_y+dh-hh/5));
               g.drawLine(ww-5,h-hh-(int)Math.round(j*k_y+dh),w,h-hh-(int)Math.round(j*k_y+dh));
               i=i+1;}else{
               i=0;
            }
         }
         j=j-step;
      }
      step=Math.abs((max_x-min_x)/50);
      j=0; i=0;
      while(j<=max_x && min_x!=max_x){
         if(j>=min_x && j<=max_x){
            g.setColor(Color.gray);
            g.drawLine(ww+(int)Math.round(j*k_x+dw),1,ww+(int)Math.round(j*k_x+dw),h-hh);
            if(i==0){
               g.setColor(Color.black);
               st = j+"";
               st = st.substring(0,st.indexOf('.')+2);
               int xi = ww+(int)Math.round(j*k_x+dw-fm.stringWidth(st)/2f);
               if(w-xi>=fm.stringWidth(st)){
                  g.drawString(st,xi,(int)(h-hh+5+hh*0.5f));
               }
               g.drawLine(ww+(int)Math.round(j*k_x+dw),1,ww+(int)Math.round(j*k_x+dw),h-hh+5);
               i=i+1;}else
               if(i==4){i=0;}else{i=i+1;
            }
         }
         j=j+step;
      }
      j=0; i=0;
      while(j>=min_x && min_x!=max_x){
         if(j>=min_x && j<=max_x){
            g.setColor(Color.gray);
            g.drawLine(ww+(int)Math.round(j*k_x+dw),1,ww+(int)Math.round(j*k_x+dw),h-hh);
            if(i==0){
               g.setColor(Color.black);
               st = j+"";
               st = st.substring(0,st.indexOf('.')+2);
               g.drawString(st,ww+(int)Math.round(j*k_x+dw-fm.stringWidth(st)/2f),(int)(h-hh+5+hh*0.5f));
               g.drawLine(ww+(int)Math.round(j*k_x+dw),1,ww+(int)Math.round(j*k_x+dw),h-hh+5);
               i=i+1;}else
               if(i==4){i=0;}else{i=i+1;
            }
         }
         j=j-step;
      }
      j=0;
      if(data!=null){
      	for(i=0; i<data.size(); i=i+1){
      	 if(pointOn){
           YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
           g.setColor(p.color);
           int x=ww+(int)Math.round(p.x*k_x+dw);
           int y=h-hh-(int)Math.round(p.y*k_y+dh);
           if(x>=ww && y<=(h-hh)){
           	g.drawRect(-POINT_SIZE+x,-POINT_SIZE+y,POINT_SIZE*2,POINT_SIZE*2);
            g.drawString((i+1)+"",x,y-POINT_SIZE-2);           
           }
      	 }
      	}
      	if(modeCurve==0 && 1<data.size()){
        	dataAll = new Vector();
        	for(i=0; i<data.size(); i++){
        		YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
        		dataAll.addElement(new YPoint2f(p.x,p.y));
          }
      		for(i=0; i<data.size(); i=i+1){
      			if(i+1<data.size()){
      				YChartPoint2f p1 = (YChartPoint2f)data.elementAt(i);
              YChartPoint2f p2 = (YChartPoint2f)data.elementAt(i+1);
              g.setColor(p1.color);
              int x1=ww+(int)Math.round(p1.x*k_x+dw);
              int x2=ww+(int)Math.round(p2.x*k_x+dw);
              int y1=h-hh-(int)Math.round(p1.y*k_y+dh);
              int y2=h-hh-(int)Math.round(p2.y*k_y+dh);
              if(x1>=ww && x2>=ww && y1<=(h-hh) && y2<=(h-hh)){
              	drawPLine(g,x1,y1,x2,y2);
              }
            }
      		}
        }else if(1<data.size()){
        	dataAll = new Vector();
        	YPoint2f endPoint = new YPoint2f();
        	int namber1 = 0;
        	int namber2 = 0;
        	Vector dataOld = new Vector();
        	for(i=0; i<data.size(); i++){
        		dataOld.addElement(data.elementAt(i));
          }
        	switch (modeCurve) {
        		case 1: 
            case 2: 
            	if(Math.floor((data.size()-1)/3f)!=((data.size()-1)/3f)){
        			  for(i=(int)(Math.floor((data.size()-1)/3f)+1)*3+1-data.size(); i>0; i--){
        			  	data.addElement(data.elementAt(data.size()-1));
        		    }
        		  }
        		  break; 
        		case 3: 
        			data.insertElementAt(data.elementAt(0),0);
        		  data.insertElementAt(data.elementAt(0),0);
        		  data.addElement(data.elementAt(data.size()-1));
        		  data.addElement(data.elementAt(data.size()-1));
        	}
        	for(i = 0; i < data.size()-3;) {
	// Four control points are needed to create a curve.
	// If all the control points are used, the last series of four 
	// points begins with point np-4.
	          g.setColor(((YChartPoint2f)data.elementAt(i)).color);
	          switch (modeCurve) {
		// The geometry matrix for a series of control points is
		// different for each curve type.
		          case 1:
		          	geom[0][0] = ((YChartPoint2f)data.elementAt(i)).x;
	    	        geom[0][1] = ((YChartPoint2f)data.elementAt(i)).y;
	    	        geom[1][0] = ((YChartPoint2f)data.elementAt(i+3)).x;
	    	        geom[1][1] = ((YChartPoint2f)data.elementAt(i+3)).y;
	    	        geom[2][0] = ((YChartPoint2f)data.elementAt(i+1)).x-geom[0][0];
	    	        geom[2][1] = ((YChartPoint2f)data.elementAt(i+1)).y-geom[0][1];
	    	        geom[3][0] = geom[1][0]-((YChartPoint2f)data.elementAt(i+2)).x;
	    	        geom[3][1] = geom[1][1]-((YChartPoint2f)data.elementAt(i+2)).y;
		            multMatrix(hermiteMatrix, geom, mg);
		    // The beginning of the next Hermite curve is the last
		    // point of the previous curve.
		           i += 3;
		           break;
	           case 2:
		           for(int jj = 0; jj <4 ;jj++) {
		           	geom[jj][0] = ((YChartPoint2f)data.elementAt(i+jj)).x;
	    	        geom[jj][1] = ((YChartPoint2f)data.elementAt(i+jj)).y;
	      		   }
	      		   multMatrix(bezierMatrix, geom, mg);
		    // The beginning of the next Bezier curve is the last
		    // point of the previous curve.
		           i += 3;
		           break;
	           case 3:
		           for(int jj = 3; jj >= 0; jj--) {
		           	geom[3-jj][0] = ((YChartPoint2f)data.elementAt(i+jj)).x;
	    	        geom[3-jj][1] = ((YChartPoint2f)data.elementAt(i+jj)).y;
		           }	
		           multMatrix(bsplineMatrix, geom, mg);
		    // B-Spline is the slowest curve, since the beginning of
		    // the next series of four control points is the second
		    // control point of the previous series.
		           i++;
		           break;
	          }
	     // In order to plot the curve using forward differences
	     // (a speedier way to plot the curve), another matrix
	     // calculation is required, taking into account the precision
	     // of the curve.
	          multMatrix(eMatrix, mg, plot);
	          float startX = plot[0][0];
	          float x = startX;
	          float startY = plot[0][1];
	          float y = startY;
	     // Plot the curve using the forward difference method
	          for(int jj=0; jj<precision; jj++) {
	          	x += plot[1][0];
		          plot[1][0] += plot[2][0];
		          plot[2][0] += plot[3][0];
		          y += plot[1][1];
		          plot[1][1] += plot[2][1];
		          plot[2][1] += plot[3][1];
              int x1=ww+(int)Math.round(startX*k_x+dw);
              int x2=ww+(int)Math.round(x*k_x+dw);
              int y1=h-hh-(int)Math.round(startY*k_y+dh);
              int y2=h-hh-(int)Math.round(y*k_y+dh);
              if(modeCurve==3){
              	dataAll.insertElementAt(new YPoint2f(startX,startY),namber2);
              	namber1 = namber1 + 1;
              }else dataAll.addElement(new YPoint2f(startX,startY));
              endPoint = new YPoint2f(x,y);
              if(x1>=ww && x2>=ww && y1<=(h-hh) && y2<=(h-hh)){
              	drawPLine(g,x1,y1,x2,y2);
              }
		          startX = x;
		          startY = y;
	          }
	          namber2 = namber1;
	       }
         dataAll.addElement(endPoint);
	       data=new Vector();
	       for(i=0; i<dataOld.size(); i++){
	       	data.addElement(dataOld.elementAt(i));
         }
        }
      }
    }
    g.setColor(Color.black);
    g.drawRect(ww,1,w-ww,h-hh-1);
	}

  public void setData(Vector v){
    data = v;
    window[0] = new YPoint2f();
    window[1] = new YPoint2f();    
    repaint();
	}
  public Vector getData(){
    return data;
	}
  public void showPoint(boolean b) {
	  pointOn=b;
    repaint();	  
  }
  
  public void setCoordinates(boolean b) {
	  coordinates=b;
    if(b){xyz.show();}else{xyz.setVisible(false);}	  
  }
  
  public void setProportional(boolean b) {
	  proportional=b;
    repaint();	  
  }

  public void setWindow(YPoint2f[] w){
    window = w;
    repaint();
	}
 
  public YPoint2f[] getWindowSize(){
    return window;
	}

	public void function(String fun, float start, float end, float step, Color color){
		Vector v = new Vector();
		functionString=fun;
		functionStart=start;
		functionEnd=end;
		functionStep=step;
		if(fun.trim().length()<1)return;
		YCalc.setFunction(fun);
		while(start<=end){
			try{
		  		v.addElement(new YChartPoint2f(start, (float)YCalc.calc(start), color));
 		  }catch(Exception e1) {System.out.println(e1);}
 		  start=start+step;
 	  }
 	  setData(v);
	}
	
  private boolean inPoint(YChartPoint2f p,int x,int y) {
  	if(pointOn && p.x>=(min_x+(x-POINT_SIZE-ww)/kx)
  		&& p.x<=(min_x+(x+POINT_SIZE-ww)/kx) 
  		&& p.y>=(min_y+(getSize().height-2-hh-y-POINT_SIZE)/ky)
  		&& p.y<=(min_y+(getSize().height-2-hh-y+POINT_SIZE)/ky))
  		return true;
	  else 
	  	return false;
  }    
  private YChartPoint2f getRealPoint(int x,int y){
 		return new YChartPoint2f(min_x+(x-ww)/kx, min_y+(getSize().height-2-hh-y)/ky);
  }
  
	public void setModePoint(int mode){
    // Change the curve display type
  	switch (mode) {
	    case 0:
	    case 1:
	    case 2:
	    case 3:
	    case 4:
	      modePoint = mode;
	      break;
	    default:  throw new IllegalArgumentException();
	  }
	}
	public int getModePoint(){
		return modePoint;
	}
	public void setModeCurve(int mode) {
    // Change the curve display type
  	switch (mode) {
	    case 0:
	    case 1:
	    case 2:
	    case 3:
	      modeCurve = mode;
	      repaint();
	      break;
	    default:  throw new IllegalArgumentException();
	  }
  }
 	public int getModeCurve(){
		return modeCurve;
	}
  private void deletePoint(int x, int y){
    if(data!=null){
    	for(int i=0; i<data.size(); i=i+1){
    		YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
    		if(inPoint(p,x,y)){
    			if(data.size()==2 && window[0].x==0 && window[1].x==0 && window[0].y==0 && window[1].y==0){
    				window[0]=(YPoint2f)data.elementAt(0);
    				window[1]=(YPoint2f)data.elementAt(1);
    				setWindow(window);
    			}
   				data.removeElementAt(i);
    			repaint();
    			return;
    		}
    	}
    }
	}

  private void editPoint(int x, int y){
    if(data!=null){
    	for(z=0; z<data.size(); z=z+1){
    		YChartPoint2f p = (YChartPoint2f)data.elementAt(z);
    		if(inPoint(p,x,y)){
   	    	dialog = new YDialog(parentOf(),"Edit Point");
     	  	dialog.setSize(380,130);
     	  	dialog.setLayout(new YVerticalFlowLayout(0,1,0,true,false));
    	  	Panel p1 = new Panel();
    	  	Panel p2 = new Panel();
    	  	dialog.add(p1);
   	    	dialog.add(p2);
   	    	PointX = new TextField(10);
          PointY = new TextField(10);
          PointX.setText(p.x+"");
          PointY.setText(p.y+"");
     	  	p1.add(new Label("X="));
    	  	p1.add(PointX);
    	  	p1.add(new Label("Y="));
   	    	p1.add(PointY);
   	    	Button ok = new Button("OK"); 
   	    	Button cancel = new Button("Cancel"); 
   	    	p2.add(ok); 
   	    	ok.addMouseListener(new MouseAdapter() {
   	    		public void  mouseClicked(MouseEvent e) {
   	    			try{
   	    				YChartPoint2f[] window = {new YChartPoint2f(),new YChartPoint2f()};
   	    			 	Float f = Float.valueOf(PointX.getText());
  	      	    float xx = f.floatValue();
  	      	    f = Float.valueOf(PointY.getText());
  	      	    float yy = f.floatValue();
                data.setElementAt(new YChartPoint2f(xx,yy),z);repaint();
   	    		  	dialog.dispose();
   	    			}catch(Exception e1) {YDialog d=new YDialog(parentOf(),"Error!","Error: "+e1,true);d.show();System.out.println(e1);}   	  			
   	    		}
   	    	});
   	    	p2.add(cancel); 
   	    	cancel.addMouseListener(new MouseAdapter() {
   	    		public void  mouseClicked(MouseEvent e) {
   	    			dialog.dispose();
   	    		}
   	    	});   	  	
   	    	dialog.show();	  	
    			return;
    		}
    	}
    }
	}
	
  private void addPoint(int x, int y){
  	YChartPoint2f p = getRealPoint(x,y);
    if(Float.NaN!=p.x && Float.NaN!=p.y && Float.NEGATIVE_INFINITY!=p.x && Float.POSITIVE_INFINITY!=p.x && Float.NEGATIVE_INFINITY!=p.y && Float.POSITIVE_INFINITY!=p.y){
    	if(data==null){data = new Vector();}
    	data.addElement(p);
    	repaint();
    }
	}
  private int getIndexPoint(int x, int y){
    if(data!=null){
    	for(int i=0; i<data.size(); i=i+1){
    		YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
    		if(inPoint(p,x,y))return i;
    	}
    }
    return -1;
	}

	private void insertPoint(int x, int y){
  	YChartPoint2f p = getRealPoint(x,y);
    if(Float.NaN!=p.x && Float.NaN!=p.y && Float.NEGATIVE_INFINITY!=p.x && Float.POSITIVE_INFINITY!=p.x && Float.NEGATIVE_INFINITY!=p.y && Float.POSITIVE_INFINITY!=p.y){
    	if(data==null){
    		data = new Vector();
    //		data.addElement(p);
    	}else{
    	  for(int i=0; i<data.size(); i=i+1){
    	  	YChartPoint2f pd = (YChartPoint2f)data.elementAt(i);
    		  if(p.x<pd.x){data.insertElementAt(p,i);repaint(); return;}
    	  }
    	}
    	data.addElement(p);    	
    	repaint();
    }
	}
  
  private void calcEMatrix(int prec) {
    // In order to use the "forward difference" method of curve plotting,
    // we must generate this matrix.  The parameter indicates the precision;
    // the number of line segments to use for each curve.
	  float step = (float) (1.0/(float)prec);
	  eMatrix[0][0] = 0;
  	eMatrix[0][1] = 0;
  	eMatrix[0][2] = 0;
  	eMatrix[0][3] = 1;
  	eMatrix[1][2] = step;
	  eMatrix[1][1] = eMatrix[1][2] * step;
	  eMatrix[1][0] = eMatrix[1][1] * step;
	  eMatrix[1][3] = 0;
    eMatrix[2][0] = 6 * eMatrix[1][0]; 
  	eMatrix[2][1] = 2 * eMatrix[1][1];
  	eMatrix[2][2] = 0;
  	eMatrix[2][3] = 0;
  	eMatrix[3][0] = eMatrix[2][0];
  	eMatrix[3][1] = 0;
	  eMatrix[3][2] = 0;
	  eMatrix[3][3] = 0;
  }
  private void multMatrix(float m[][], float g[][], float mg[][]) {
    // This function performs the meat of the calculations for the
    // curve plotting.  Note that it is not a matrix multiplier in the
    // pure sense.  The first matrix is the curve matrix (each curve type
    // has its own matrix), and the second matrix is the geometry matrix
    // (defined by the control points).  The result is returned in the
    // third matrix.

	// First clear the return array
  	for(int i=0; i<4; i++) 
	    for(int j=0; j<2; j++) 
	     	mg[i][j]=0;

	// Perform the matrix math
	  for(int i=0; i<4; i++) 
	    for(int j=0; j<2; j++) 
		    for(int k=0; k<4; k++) 
		      mg[i][j]=mg[i][j] + (m[i][k] * g[k][j]);
  }

  private void drawPLine(Graphics g,int x1,int y1,int x2,int y2){
  	g.drawLine(x1,y1,x2,y2);
    g.drawLine(1+x1,y1,1+x2,y2);
    g.drawLine(x1-1,y1,x2-1,y2);
    g.drawLine(x1,1+y1,x2,1+y2);
    g.drawLine(x1,y1-1,x2,y2-1);
  }
  	
  public void setPrecision(int i){
	  precision = i;
	  calcEMatrix(i);
	  repaint();
	}
  public int getPrecision(){
	  return precision;
  }
  private Frame parentOf() {
  	Frame f = null;
  	Component c = this.getParent();
    if (c instanceof Frame){f = (Frame)c;}
  	while (f == null) {
  		c = c.getParent();
  		if (c instanceof Frame)
  			f = (Frame)c;
  	}
  	return f;
  }
  public void open(String st){
	  if(!st.equals("nullnull")){
	  	try{
	  		FileInputStream in = new FileInputStream(st);
	  	  int b = in.read();
	  	  Vector v = new Vector();
	  	  String x = "";
	  	  String st1 = "";
	  	  while(b!=-1){
	  	  	if((((char)b)=='\n' || ((char)b)==' ') && st1.trim().length()!=0){
	  	  		if(x.length()==0)
	  	  			x = st1;
	  	  		else{ 
	  	  			try{
	  	  				v.addElement(new YChartPoint2f(new Float(x).floatValue(),new Float(st1).floatValue())); 
	  	  				x = "";
	  	  			}catch(Exception e) {System.out.println(e); x = "";}
	  	  		}
	  	  		st1 = "";
	  	  	}else if((char)b=='1' || (char)b=='2' || (char)b=='3' ||
	  	  		       (char)b=='4' || (char)b=='5' || (char)b=='6' ||
	  	  		       (char)b=='7' || (char)b=='8' || (char)b=='9' ||
	  	  		       (char)b=='0' || (char)b=='-' || (char)b=='.') st1 = st1 + (char)b;
	  		  b=in.read();
	  	  }
	  	  if(v.size()>1){setData(v);}
	  	}catch(Exception e) {System.out.println(e);}
	  }
  }
  public void save(String st){
	  if(!st.equals("nullnull") && data!=null){
	  	try{
	  		FileOutputStream out = new FileOutputStream(st);
        for(int i=0; i<data.size(); i++){
        	YChartPoint2f p = (YChartPoint2f)data.elementAt(i);
        	out.write((p.x+" "+p.y+"\n").getBytes());
        }
        out.close();
	  	}catch(Exception e) {System.out.println(e);}
	  }
  }
  public Vector getDataAll(){
	  if(dataAll!=null && dataAll.size()>1){
	  	YPoint2f pStart = (YPoint2f)dataAll.elementAt(0);
      for(int i=1; i<dataAll.size(); i++){
      	YPoint2f p = (YPoint2f)dataAll.elementAt(i);
      	if(pStart.x==p.x && pStart.y==p.y){
      		dataAll.removeElementAt(i);
      		i=i-1;
      	}else pStart = p;
      }
      if(dataAll.size()<2)dataAll=null;
      return dataAll;
	  }else return null;
  }


	
	
}