package YClass;

import java.awt.*;
import java.util.Vector;
import java.awt.event.*;

public class YChartControl extends Panel {
	public YChart chart = new YChart();
	private Checkbox coordinates = new Checkbox("Coordinates",false);
	private Checkbox proportional = new Checkbox("Scale X=Y",false);
	private Button open = new Button("Open");	
	private Button save = new Button("Save");		
	private Button window = new Button("Window");	
	private Button function = new Button("Function");		
	private CheckboxGroup groupCurve = new CheckboxGroup();
	private Label precValue = new Label("Precision-15");
	private Scrollbar precision = new Scrollbar(Scrollbar.HORIZONTAL, 15, 10, 2, 50);
	private Checkbox checkLine = new Checkbox("Line",groupCurve,true);
	private Checkbox checkHermite = new Checkbox("Hermite",groupCurve,false);	
	private Checkbox checkBezier = new Checkbox("Bezier",groupCurve,false);
	private Checkbox checkBspline = new Checkbox("B-Spline",groupCurve,false);
	private Checkbox pointOn = new Checkbox("Show Point",true);	
	private CheckboxGroup groupPoint = new CheckboxGroup();
	private Checkbox checkAdd = new Checkbox("Add Point",groupPoint,false);
	private Checkbox checkEdit = new Checkbox("Edit Point",groupPoint,true);
	private Checkbox checkInsert = new Checkbox("Insert Point",groupPoint,false);	
	private Checkbox checkMove = new Checkbox("Move Point",groupPoint,false);
	private Checkbox checkDelete = new Checkbox("Delete Point",groupPoint,false);
	private Button clear = new Button("Clear");
	private YColorChoice colorControl = new YColorChoice();
	private YColorChoice colorBackground = new YColorChoice();
	private Color color = Color.black;
	private YDialog dialog;
  private TextField x1;
  private	TextField x2;
  private	TextField y1;
  private	TextField y2;
	

    /**
     * Creates a ChartControl.
     */
  public YChartControl() {
  	this.setLayout(new BorderLayout());
    this.setBackground(SystemColor.control);
    this.add(chart,BorderLayout.CENTER);
    Panel control = new Panel(new YVerticalFlowLayout(0,1,0,true,false));
    ScrollPane sp = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
    Dimension dim = sp.getSize();
    sp.setSize(new Dimension(dim.width+3,dim.height));
    sp.add(control, BorderLayout.CENTER);
    this.add(sp,BorderLayout.EAST);
    showPoint(true);
    control.add(coordinates);
    coordinates.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(coordinates.getState()){setCoordinates(true);}else{setCoordinates(false);};
      }
    });
    control.add(proportional);
    proportional.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(proportional.getState()){
   	  		setProportional(true);
   	  	}else{
   	  		setProportional(false);
   	  	}
      }
    });
    control.add(open);
    open.addMouseListener(new MouseAdapter() {
   	  public void  mouseReleased(MouseEvent e) {
   	  	FileDialog fd = new FileDialog(parentOf(), "File Dialog", FileDialog.LOAD);
   	  	fd.show();
   	  	open(fd.getDirectory()+fd.getFile());
   	  }
    });
    control.add(save);
    save.addMouseListener(new MouseAdapter() {
   	  public void  mouseReleased(MouseEvent e) {
   	  	FileDialog fd = new FileDialog(parentOf(), "File Dialog", FileDialog.SAVE);
   	  	fd.show();
 	  		save(fd.getDirectory()+fd.getFile());
   	  }
    });
    control.add(window);
    window.addMouseListener(new MouseAdapter() {
   	  public void  mouseReleased(MouseEvent e) {
   	  	dialog = new YDialog(parentOf(),"Window");
   	  	dialog.setLayout(new YVerticalFlowLayout(0,1,0,true,false));
   	  	Panel p1 = new Panel();
   	  	Panel p2 = new Panel();
   	  	Panel p3 = new Panel();
   	  	dialog.add(p1);
   	  	dialog.add(p2);
   	  	dialog.add(p3);
   	  	YPoint2f[] win = {new YPoint2f(),new YPoint2f()};
   	  	win = getWindowSize();
   	  	if(win[0].x!=win[1].x && win[0].y!=win[1].y){
   	  		 x1 = new TextField(win[0].x+"",4);
           x2 = new TextField(win[1].x+"",4);
           y1 = new TextField(win[0].y+"",4);
           y2 = new TextField(win[1].y+"",4);
   	  	}else{
   	  		x1 = new TextField(4);
          x2 = new TextField(4);
          y1 = new TextField(4);
          y2 = new TextField(4);
   	  	}
   	  	p1.add(new Label("First corner:"));
   	  	p1.add(x1);
   	  	p1.add(y1);
   	  	p2.add(new Label("Other corner:"));
   	  	p2.add(x2);
   	  	p2.add(y2);
   	  	Button ok = new Button("OK"); 
   	  	Button cancel = new Button("Cancel"); 
   	  	p3.add(ok); 
   	  	ok.addMouseListener(new MouseAdapter() {
   	  		public void  mouseClicked(MouseEvent e) {
   	  			try{
   	  				YPoint2f[] win1 = {new YPoint2f(),new YPoint2f()};
   	  			 	Float f = Float.valueOf(x1.getText());
  	    	    float xx1 = f.floatValue();
  	    	    f = Float.valueOf(x2.getText());
  	    	    float xx2 = f.floatValue();
  	    	    f = Float.valueOf(y1.getText());
  	    	    float yy1 = f.floatValue();
  	    	    f = Float.valueOf(y2.getText());
  	    	    float yy2 = f.floatValue();
   	  		  	win1[0]= new YPoint2f(xx1,yy1);
   	  		  	win1[1]= new YPoint2f(xx2,yy2);
   	  		  	setWindow(win1);
   	  		  	dialog.dispose();
   	  			}catch(Exception e1) {YDialog d=new YDialog(parentOf(),"Error!","Error: "+e1,true);d.show();;System.out.println(e1);}   	  			
   	  		}
   	  	});
   	  	p3.add(cancel); 
   	  	cancel.addMouseListener(new MouseAdapter() {
   	  		public void  mouseClicked(MouseEvent e) {
   	  			dialog.dispose();
   	  		}
   	  	});   	  	
   	  	dialog.show();
      }
    });
    control.add(function);
    function.addMouseListener(new MouseAdapter() {
   	  public void  mouseClicked(MouseEvent e) {
   	  	dialog = new YDialog(parentOf(),"Function");
   	  	Panel p1 = new Panel();
   	  	Panel p2 = new Panel();
   	  	Panel p3 = new Panel();
   	  	dialog.add(p1, BorderLayout.NORTH);
   	  	dialog.add(p2, BorderLayout.CENTER);
   	  	dialog.add(p3, BorderLayout.SOUTH);
   	  	x1 = new TextField(chart.functionString,25);
        x2 = new TextField(chart.functionStart+"");
        y1 = new TextField(chart.functionEnd+"");
        y2 = new TextField(chart.functionStep+"");
   	  	p1.add(new Label("Y(x)=",Label.RIGHT));
   	  	p1.add(x1);
   	  	p2.add(new Label("Start x=",Label.RIGHT));
   	  	p2.add(x2);
   	  	p2.add(new Label("End x=",Label.RIGHT));
   	  	p2.add(y1);
   	  	p2.add(new Label("Step x=",Label.RIGHT));
   	  	p2.add(y2);
   	  	Button ok = new Button("OK"); 
   	  	Button cancel = new Button("Cancel"); 
   	  	p3.add(ok); 
   	  	ok.addMouseListener(new MouseAdapter() {
   	  		public void  mouseClicked(MouseEvent e) {
   	  			try{
      		    Vector v = new Vector();
		          float n,k,s;
	      	    Float f;
	        		f = Float.valueOf(x2.getText());
      		    n =	f.floatValue();
  	    	    f = Float.valueOf(y1.getText());
  	    	    k =	f.floatValue();
  	    	    f = Float.valueOf(y2.getText());
  	    	    s =	f.floatValue();
  	    	    function(x1.getText(), n, k, s, color);
   	  		  	dialog.dispose();
   	  			}catch(Exception e1) {YDialog d=new YDialog(parentOf(),"Error!","Error: "+e1,true);d.show();;System.out.println(e1);}   	  			
   	  		}
   	  	});
   	  	p3.add(cancel); 
   	  	cancel.addMouseListener(new MouseAdapter() {
   	  		public void  mouseClicked(MouseEvent e) {
   	  			dialog.dispose();
   	  		}
   	  	});   	  	
   	  	dialog.setSize(400,170);
   	  	dialog.show();	  	
      }
    });
    control.add(precValue);
    control.add(precision);
    precision.addAdjustmentListener(new AdjustmentListener() {
   	  public void  adjustmentValueChanged(AdjustmentEvent e) {
   	  	precValue.setText("Precision-"+precision.getValue());
   	  	setPrecision(precision.getValue());
      }
    });  	        
    control.add(checkLine);
    checkLine.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkLine.getState()){setModeCurve(0);}
      }
    });  	    
    control.add(checkHermite);
    checkHermite.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkHermite.getState()){setModeCurve(1);}
      }
    });  	
    control.add(checkBezier);
    checkBezier.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkBezier.getState()){setModeCurve(2);}
      }
    });  	
    control.add(checkBspline);
    checkBspline.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkBspline.getState()){setModeCurve(3);}
      }
    });  	
    control.add(pointOn);
    pointOn.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(pointOn.getState()){showPoint(true);}else{showPoint(false);};
      }
    });
    control.add(checkAdd);
    checkAdd.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkAdd.getState()){setModePoint(0);}
      }
    });  	
    control.add(checkEdit);
    checkEdit.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkEdit.getState()){setModePoint(1);showPoint(true);}
      }
    });
    control.add(checkInsert);
    checkInsert.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkInsert.getState()){setModePoint(2);}
      }
    });
    control.add(checkMove);
    checkMove.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkMove.getState()){setModePoint(3);showPoint(true);}
      }
    });  	
    control.add(checkDelete);
    checkDelete.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	if(checkDelete.getState()){setModePoint(4);showPoint(true);}
      }
    });  	
    control.add(clear);
    clear.addMouseListener(new MouseAdapter() {
   	  public void  mousePressed(MouseEvent e) {
   	  	clearData();
      }
    });
    control.add(new Label("Color"));
    control.add(colorControl);
    colorControl.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	setColor(colorControl.getColor());
      }
    });  	
    control.add(new Label("Background"));
    control.add(colorBackground);
    colorBackground.addItemListener(new ItemListener() {
   	  public void  itemStateChanged(ItemEvent e) {
   	  	setColorBackground(colorBackground.getColor());   	  	
      }
    });  	
  }
  
  public void setData(Vector v){
    chart.setData(v);
	}

  public Vector getData(){
    return chart.getData();
	}
	  
  public void setColor(Color cl){
    Vector v = chart.getData();
    Vector v1 = new Vector();
    if(v==null){return;}
    YChartPoint2f p;
    for(int i=0; i<v.size(); i++){
    	p = (YChartPoint2f)v.elementAt(i);
    	p.color=cl;
    	v1.addElement(p);
    }
    setData(v1);
    color=cl;
	}
	
  public void setColorBackground(Color cl){
    chart.setBackground(cl);
	}
	
  public void clearData() {
	  chart.setData(null);
  }

  public void showPoint(boolean b) {
  	pointOn.setState(b);
	  chart.showPoint(b);
  }
   
  public void setWindow(YPoint2f[] w){
    chart.setWindow(w);
	}
	
	public YPoint2f[] getWindowSize(){
    return chart.getWindowSize();
	}

  public void setCoordinates(boolean b){
    chart.setCoordinates(b);
	}
	
	public void setProportional(boolean b){
    chart.setProportional(b);
	}
	
	public void function(String fun, float start, float end, float step, Color color){
    chart.function(fun, start, end, step, color);		
	}
  public void setModePoint(int i){
		chart.setModePoint(i);
	}
  public void setModeCurve(int i){
		chart.setModeCurve(i);
	}
  public void setPrecision(int i){
		chart.setPrecision(i);
	}
  private Frame parentOf() {
  	Frame f = null;
  	Component c = this.getParent();
    if (c instanceof Frame){f = (Frame)c;}
  	while (f == null) {
  		c = c.getParent();
  		if (c instanceof Frame)
  			f = (Frame)c;
  	}
  	return f;
  }

  public void open(String st){
  	chart.open(st);
  }

  public void save(String st){
  	chart.save(st);
  }
  public Vector getDataAll(){
  	return chart.getDataAll();
  }
  

}